

var TQ TQSTAR RFD RTB TOTREV TOTREVSTAR TOTEXPEND TOTEXPENDSTAR  T  TSTAR D DSTAR INV INVSTAR NTB CR CRSTAR  C  CSTAR L LSTAR Z ZSTAR Y YSTAR YH YFSTAR  YF YHSTAR  P PSTAR PF PHSTAR  PH PFSTAR PHPCP PFSTARPCP  PHSTARPCP  PFPCP W WSTAR MUW MUWSTAR MC MCSTAR
INFPH INFPF INFPHSTAR INFPFSTAR NCA F R RSTAR K KSTAR ROK ROKSTAR INF INFSTAR S  Q A ASTAR  PHI PHISTAR   G GSTAR TASTE TASTESTAR RP  ;


varexo epsg epsgstar epsphi epsphistar epsa epsastar epsrp epstaste epstastestar ;

parameters b1 b2 b1s b2s  a3 a3s a4 a4s a1 a2  a1s a2s   rhogstar rhog sbar pbar ybar cbar gbar inbar kappaf sigma1 h  sigma3 sigma1s hs omega omegas sigma3s psibar thetah thetahs thetaf thetafs mu mus beta delta alpha kk kks rhophi  rhophistar rhoa rhoastar  rhotaste rhorp rhotastestar  ;



omega=0               ;                 
omegas=0;
h=0.7;                     
hs=0.7;

//----------------------------------------------------
psibar= 0.5;                
kk= 2 ;               
kks=2 ;
a1=1.5;                    
a2=0.01;                     
a3=0.03 ;                    
a4= 0.84;                    
a1s=1.5 ;  
a2s=0.03;               
a3s=0.02;
a4s=0.86;
b1 = .9 ;
b1s=.9;  
b2 =0.02; 
b2s=0.02;  

kappaf= 0.03 ;               
sigma1=1;                 
sigma1s=1;
sigma3=1;              
sigma3s=1;    
thetah= 0.5;               
thetahs =0.5;              
thetaf=0.5;                
thetafs=0.5;                
mu=1.5;                     
mus=1.5;


alpha=0.33;                 
beta=0.99;                  
delta=0.025;                
pbar=100;                  
sbar=1;                     
ybar=1000;                  
cbar= 600;                  
gbar= 200;                  
inbar=200;                 



rhoa=0.9;                  
rhog=0.9;                 
rhophi=0.9;                
rhorp=0.9;                 
rhotaste=.9;              


rhogstar=0.9; 
rhoastar=0.9;
rhophistar=0.9;
rhotastestar=0.9;


model(linear);
PHI=rhophi*(PHI(-1))+epsphi;
PHISTAR=rhophistar*(PHISTAR(-1))+epsphistar; 

A=rhoa*(A(-1))+epsa;
ASTAR=rhoastar*(ASTAR(-1))+epsastar;

 
RP=rhorp*(RP(-1))+ epsrp;

G=rhog*G(-1)+ epsg ;
GSTAR=rhogstar*GSTAR(-1)+ epsgstar ;



TASTE=rhotaste*(TASTE(-1))+epstaste;
TASTESTAR=rhotastestar*(TASTESTAR(-1))+epstastestar; 


R=a4*R(-1)+(1-a4)*(a1*INF + a2*Y + a3*(S ))+ PHI;                              

RSTAR=a4s*RSTAR(-1)+(1-a4s)*(a1s*INFSTAR + a2s*YSTAR - a3s*(S))+ PHISTAR;     

// GOVERNMENT
//DEBT
D = (1/beta)*D(-1) +G - b1*G - b2*D ;
RFD= D-D(-1);
DSTAR = (1/beta)*DSTAR(-1) +GSTAR - b1s*GSTAR - b2s*DSTAR ;
TOTEXPEND= G + ((1/beta)/beta)*D(-1);
TOTEXPENDSTAR=GSTAR + ((1/beta)/beta)*DSTAR(-1);
TOTREV= T ;
TOTREVSTAR= TSTAR ;
                                    

T= b1*G +b2*D;
TSTAR=b1s*GSTAR + b2s*DSTAR;


(1/(1- psibar)*pbar)*NTB=S-(PF-PHSTAR)-(YF-YHSTAR);
RTB= NTB/pbar;
 

Q=S+PSTAR-P;


sbar*F= NTB +(1/beta)*sbar*F(-1);


NCA= sbar*(F-F(-1));

 
(S(+1)-S)= (R-RSTAR)+ kappaf*ybar*F - RP;

PHPCP-MC+((beta*thetah)/(1-beta*thetah))*(PHPCP-PHPCP(+1))+ (beta*thetah/(1-beta*thetah))*INFPH=0;                      
PFSTARPCP-MCSTAR+(beta*thetafs/(1-beta*thetafs))*(PFSTARPCP-PFSTARPCP(+1))+ (beta*thetafs/(1-beta*thetafs))*INFPFSTAR=0;


PHSTARPCP-MC+((beta*thetahs)/(1-beta*thetahs))*(PHSTARPCP-PHSTARPCP(+1))+ ((beta*thetahs)/(1-beta*thetahs))*(INFPHSTAR)=0; 
PFPCP-MCSTAR+(beta*thetaf/(1-beta*thetaf))*(PFPCP-PFPCP(+1))+ (beta*thetaf/(1-beta*thetaf))*INFPF=0;                       


PH=PHPCP + (thetah/(1-thetah))*(INFPH(-1)-INFPH);                 
PFSTAR=PFSTARPCP + (thetafs/(1-thetafs))*(INFPFSTAR(-1)-INFPFSTAR); 
 

PHSTAR=(PHSTARPCP-S)+(thetahs/(1-thetahs))*(INFPHSTAR(-1)-INFPHSTAR);       
PF=(PFPCP+S)+(thetaf/(1-thetaf))*(INFPF(-1)-INFPF);                         
  

P=psibar*PH+(1-psibar)*PF;                                                  
PSTAR= psibar*PFSTAR+(1- psibar)*PHSTAR;                                   


MC=(1-alpha)*(W-P) + alpha*ROK +P-A;                                     
MCSTAR=(1-alpha)*(WSTAR-PSTAR) + alpha*ROKSTAR +PSTAR-ASTAR;              

INF=P-P(-1);                   
INFPH=PH-PH(-1);               
INFPHSTAR= PHSTAR-PHSTAR(-1);  

INFPFSTAR=PFSTAR-PFSTAR(-1);   
INFPF=PF-PF(-1);                
INFSTAR=PSTAR-PSTAR(-1);      
 

YH=Y+mu*P-mu*PH;                                                    
YFSTAR=YSTAR+mus*PSTAR-mus*PFSTAR;                                    
 

YHSTAR=YSTAR+mus*PSTAR-mus*PHSTAR;                                        
YF=Y+mu*P-mu*PF;                                                  
 

Z= psibar *(YH)+(1- psibar)*(YHSTAR) ;                             
ZSTAR= psibar *(YFSTAR)+(1- psibar)*(YF) ;                         

Y= (cbar/ybar)*C+ (inbar/ybar)*INV + (gbar/ybar)*G ;               
YSTAR= (cbar/ybar)*CSTAR+ (inbar/ybar)*INVSTAR + (gbar/ybar)*GSTAR ;



INV = K + (kk)*TQ ;                                      
INVSTAR = KSTAR + (kks)*TQSTAR ; 


TQ = (1-beta*(1-delta))*(ROK(+1))+ beta*(1-delta)*TQ(+1) + MUW(+1) -MUW ;
TQSTAR = (1-beta*(1-delta))*(ROKSTAR(+1))+ beta*(1-delta)*TQSTAR(+1) + MUWSTAR(+1) -MUWSTAR ;


delta*INV=K-(1-delta)*K(-1);                    
delta*INVSTAR=KSTAR-(1-delta)*KSTAR(-1);        


ROK=W+L-P-K(-1);                    
ROKSTAR=WSTAR+LSTAR-PSTAR-KSTAR(-1);

Z=A+alpha*(K(-1))+(1-alpha)*(L);                                                                            
ZSTAR= ASTAR + alpha*(KSTAR(-1))+(1-alpha)*(LSTAR);                                                     


sigma3*(L)=MUW+W-P;                                                         
sigma3s*(LSTAR)= MUWSTAR+WSTAR-PSTAR;    


//--------------------------------------------------------------------------------

TASTE -sigma1*(CR-h*C(-1))/(1-h)=MUW ;                              
TASTESTAR -sigma1s*(CRSTAR-hs*CSTAR(-1))/(1-hs)=MUWSTAR ; 



MUW-P=MUW(+1)+ R - P(+1);                                                                                   //HOME 
MUWSTAR-PSTAR=MUWSTAR(+1)+ RSTAR - PSTAR(+1);                                                               //FOREIGN



C= (1-omega)*CR;                                                                                  //HOME 
CSTAR= (1-omegas)*CRSTAR;  
 

end; 
shocks;
// THE MONETARY POLICY DISTURBANCES 
//var epsphi;                       stderr 0.002;
//var epsphistar;                   stderr 0.002;


// THE TECHNOLOGY PROCESSES 
//var epsa;                         stderr 0.002;
//var epsastar;                     stderr 0.002;

// THE UNCOVERED INTEREST RATE PARITY RISK PREMIUM TERM
var epsrp;                        stderr 0.002;


//GOVT PURCHASES
var epsg ;                        stderr  0.002 ; // just started re-estimiating , after ferre. no more uniform priors.
//var epsgstar ;                    stderr 0.002;
      
// THE TASTE UNCERTAINTY 

//var epstaste ;                     stderr 0.0012;

//var epstastestar;                 stderr 0.0012; 


end;
 
//list_variables;check;
//stoch_simul (irf=0) C R ROK INV Y RTB RFD;

estimated_params;



thetahs,                        BETA_PDF,              0.75,0.12          ;
thetaf,                         BETA_PDF,              0.75,0.12           ;
mu,                             GAMMA_PDF,           1.5,    1        ; 
mus,                            GAMMA_PDF,          1.5,    1       ;
a3,                            0.03,0.01,1,                NORMAL_PDF,          0.03,    2            ;  
a3s,                            0.03,0.01,1,                NORMAL_PDF,          0.03,    2     ;
psibar,            0.55,0.51,0.8,             BETA_PDF,              0.54,0.12          ;
kappaf,            GAMMA_PDF,              0.003 ,.1 ; 
rhorp,             BETA_PDF,0.9,.01         ;
stderr epsrp,      INV_GAMMA_PDF,0.02,1 ;
rhog,              BETA_PDF,0.9,.01         ;
stderr epsg,       INV_GAMMA_PDF,0.02,1 ; 


end;
varobs   RFD   RTB ; 
estimation(datafile=Use_LT_SA, presample=1 ,nobs =144,mh_nblocks=2, mh_replic=200000, mh_jscale=0.5, mode_compute=4,mode_check, bayesian_irf); 

